/* Program  linear.cc       */
/* By Harald Stauss         */
/* Last change 21 Oct. 1995 */

#include "tsa.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

main(int argc, char *argv[])
{
  short    i,chn,rect;
  unsigned long     n;
  float    m,b;
  char     *fin,*fout,*ftin,*ftout;
  REGIST   r;

  /* H e l l o    W o r l d */

  printf("linear Ver.1.0 by H. Stauss, 1996 \n");

  /* A r r a y s   a l l o c i e r e n */
  fin=(char *)malloc(255);
  fout=(char *)malloc(255);
  ftin=(char *)malloc(255);
  ftout=(char *)malloc(255);

  if (argc != 7)
    {
      printf("Number of parameters wrong! \n");
      printf("Applies a linear equation to channel number chn \n");
      printf("Rectifies before applying the linear equation, if r=1 \n");
      printf("LINEAR fin fout chn m b r \n");
      printf("fin    : name of input file (*.asc). \n");
      printf("fout   : name of output file (*.asc). \n");
      printf("chn    : channel to be rectified (starts at 1). \n");
      printf("m      : y = m * x + b \n");
      printf("b      : y = m * x + b \n");
      printf("r      : 0: do not rectify; 1: rectify \n");
      goto ende;
    }

  /* Eingabedatei oeffnen */
  strcpy(fin,argv[1]);
  strcpy(fout,argv[2]);
  strcpy(ftin,fin);
  strcpy(ftout,fout);
  ftin=strrchr(ftin,'.');
  for (i=0; ftin[i]; i++) ftin[i]=toupper(ftin[i]);
  ftout=strrchr(ftout,'.');
  for (i=0; ftout[i]; i++) ftout[i]=toupper(ftout[i]);
  chn=atoi(argv[3]); chn--;
  m=atof(argv[4]);
  b=atof(argv[5]);
  rect=atoi(argv[6]);
  
  printf("In-File    : %s \n",fin);
  printf("Out-File   : %s \n",fout);
  cout << "Use channel : " << chn+1 << "\n";
  cout << "m           : " << m << "\n";
  cout << "b           : " << b << "\n";
  cout << "rectify     : " << rect << "\n";

  /* E i n g a b e d a t e i   o e f f n e n */
  if (strcmp(ftin,".TSA")==0) r.ReadTSA(fin);
  if (strcmp(ftin,".ASC")==0) r.ReadASCII(fin,1);
  if ((strcmp(ftin,".TSA")!=0) && (strcmp(ftin,".ASC")!=0)) {
    cout << "File type for input not recognized! \n";
    goto ende;
  }

  if (chn<0 || chn>=r.n) {
    cout << "Channel number not in the range from 1 to " << r.n << "\n";
    goto ende;
  }

  for (n=0; n<r.ch[chn].n; n++) {
    if(rect==0) r.ch[chn].data[n]=m*r.ch[chn].data[n]+b;
    if(rect==1) r.ch[chn].data[n]=m*fabs(r.ch[chn].data[n])+b;
  }

  /* D a t e i   s c h r e i b e n */
  if (strcmp(ftout,".TSA")==0) r.WriteTSA(fout);
  if (strcmp(ftout,".ASC")==0) r.WriteASCII(fout);
  if ((strcmp(ftout,".TSA")!=0) && (strcmp(ftout,".ASC")!=0)) {
    printf("File type for output not recognized! \n");
    goto ende;
  }

 ende:
  free(fin);free(ftin);free(fout);free(ftout);
  return(0);
} /* Ende von main */
